package com.gyee.cache.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 * @ClassName : SerializeUtil
 * @Author : xieshengjie
 * @Date: 2021/5/24 14:33
 * @Description : 序列化工具
 */
public class SerializeUtil {

    /**
     * 将java对象转换为byte数组 序列化过程
     */

    public static byte[] serialize(Object object) {
        ObjectOutputStream oos = null;
        ByteArrayOutputStream baos = null;
        try {
            baos=new ByteArrayOutputStream();
            oos=new ObjectOutputStream(baos);
            oos.writeObject(object);
            byte[] bytes = baos.toByteArray();
            return bytes;

        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 将byte数组转化为java对象
     * @param bytes
     * @return
     */

    public static Object unserialize(byte[] bytes){
        if (bytes==null) return null;

        ByteArrayInputStream bais=null;
        try{
            bais =new ByteArrayInputStream(bytes);
            ObjectInputStream objectInputStream = new ObjectInputStream(bais);
            return objectInputStream.readObject();
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }
}
