package com.gyee.datacenter.init;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gyee.datacenter.common.StringUtils;
import com.gyee.datacenter.model.auto.Datacenter;
import com.gyee.datacenter.model.auto.Datacenterpoint;
import com.gyee.datacenter.model.auto.Uniformcode;
import com.gyee.datacenter.model.auto.Windturbinetestingpointai2;
import com.gyee.datacenter.service.ParameterComparisonService;
import com.gyee.datacenter.service.auto.IDatacenterService;
import com.gyee.datacenter.service.auto.IDatacenterpointService;
import com.gyee.datacenter.service.auto.IUniformcodeService;
import com.gyee.datacenter.util.JSONUtil;
import com.gyee.datacenter.util.redis.RedisService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName : CacheContext
 * @Author : xieshengjie
 * @Date: 2021/5/18 9:35
 * @Description : 缓存
 */
@Component
public class CacheContext implements CommandLineRunner {

    private static final Logger log = LoggerFactory.getLogger(ParameterComparisonService.class);
    @Autowired
    private RedisService redisService;

    @Autowired
    private IDatacenterService datacenterService;
    @Autowired
    private IUniformcodeService uniformcodeService;
    public static List<Datacenter> tableList = new ArrayList<>();
    public static Map<String, List<Datacenterpoint>> pointmap = new HashMap<>();
    public static Map<String,String> inmap = new HashMap<>();
    public static List<Uniformcode> codeList = new ArrayList<>();
    public static Map<String,String> codemap = new HashMap<>();
    public static Map<String, Map<String, Windturbinetestingpointai2>> wtpointmap = new HashMap<>();
    @Override
    public void run(String... args) throws Exception {

        log.info("-------------------------------缓存开始--------------------------------------");
        tableList = datacenterService.list();

        tableList.stream().forEach(i->{
            List<Datacenterpoint> realtimedataList = JSONUtil.jsonToList(redisService.get(i.getTableid()), Datacenterpoint.class);
            if(StringUtils.isNotNull(realtimedataList)){
                pointmap.put(i.getTableid(),realtimedataList);
                realtimedataList.stream().forEach(x->{
                    inmap.put(x.getId(),x.getName());
                });
            }
        });

        codeList = uniformcodeService.list();
        codeList.stream().forEach(i->{
            codemap.put(i.getCode(),i.getDescription());
        });

        String wtjson = redisService.get("WT");
        wtpointmap = JSONObject.parseObject(wtjson, new TypeReference<Map<String, Map<String, Windturbinetestingpointai2>>>() {
        });

        log.info("-------------------------------缓存结束--------------------------------------");
    }
}
