package com.gyee.datacenter;

import com.alibaba.druid.support.json.JSONUtils;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gyee.datacenter.common.PointData;
import com.gyee.datacenter.model.auto.Datacenter;
import com.gyee.datacenter.model.auto.Datacenterpoint;
import com.gyee.datacenter.service.auto.IDatacenterService;
import com.gyee.datacenter.service.auto.IDatacenterpointService;
import com.gyee.datacenter.util.JSONUtil;
import com.gyee.datacenter.util.golden.EdosUtil;
import com.gyee.datacenter.util.golden.IEdosUtil;
import com.gyee.datacenter.util.redis.RedisService;
import com.gyee.datacenter.util.redis.RedisServiceImpl;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RunWith(SpringRunner.class)
@EnableAutoConfiguration(exclude={DataSourceAutoConfiguration.class})
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
public class DatacenterApplicationTests {
    @Autowired
    private IDatacenterpointService datacenterpointService;
    @Autowired
    private RedisService redisService;
    @Autowired
    private IDatacenterService datacenterService;
    @Test
    public void test() throws Exception {
        IEdosUtil edosUtil = new EdosUtil();
        List<String> list = new ArrayList<>();
        list.add("XSFJ.NX_GD_XSF_FJ_P1_L1_001_AI0099");
        list.add("XSFJ.NX_GD_XSF_FJ_P1_L1_001_AI0098");
        List<PointData> realData = edosUtil.getRealData(list);
        System.out.println(realData.get(0).getPointValueInDouble());
    }

    @Test
    public void testRedis() throws Exception {
        QueryWrapper<Datacenterpoint> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("tid","MCHDJL");
        List<Datacenterpoint> realtimedataList = datacenterpointService.list(queryWrapper);

        String s = JSONUtil.objectToJson(realtimedataList);
        redisService.set("MCHDJL",s);



    }

    @Test
    public void test33() throws Exception {
        QueryWrapper<Datacenterpoint> queryWrapper = new QueryWrapper<>();
        List<Datacenterpoint> list = datacenterpointService.list();

        List<String> ids = list.stream().map(i -> i.getId()).collect(Collectors.toList());
        



    }

}
